<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/CapabilityAgents/Notifications/include/Notifications/NotificationRenderer.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7cf910bd1d7603f12ef47ff650cec893.html">CapabilityAgents</a></li><li class="navelem"><a class="el" href="dir_51ceba3e0236022a3ce16bfbc638804e.html">Notifications</a></li><li class="navelem"><a class="el" href="dir_e7db36e79723a69813d4111ac7822a9d.html">include</a></li><li class="navelem"><a class="el" href="dir_a67aa551fa12014e267c750fd1c4faf6.html">Notifications</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">NotificationRenderer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_notification_renderer_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2017-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_CAPABILITYAGENTS_NOTIFICATIONS_INCLUDE_NOTIFICATIONS_NOTIFICATIONRENDERER_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_CAPABILITYAGENTS_NOTIFICATIONS_INCLUDE_NOTIFICATIONS_NOTIFICATIONRENDERER_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;unordered_set&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_media_player_interface_8h.html">AVSCommon/Utils/MediaPlayer/MediaPlayerInterface.h</a>&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_media_player_observer_interface_8h.html">AVSCommon/Utils/MediaPlayer/MediaPlayerObserverInterface.h</a>&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_requires_shutdown_8h.html">AVSCommon/Utils/RequiresShutdown.h</a>&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_notification_renderer_interface_8h.html">NotificationRendererInterface.h</a>&quot;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">namespace </span>capabilityAgents {</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="keyword">namespace </span>notifications {</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html">   35</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html">NotificationRenderer</a></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_interface.html">NotificationRendererInterface</a></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_observer_interface.html">avsCommon::utils::mediaPlayer::MediaPlayerObserverInterface</a></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">avsCommon::utils::RequiresShutdown</a></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        , <span class="keyword">public</span> std::enable_shared_from_this&lt;NotificationRenderer&gt; {</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#abd6892a98cfba046d6f02deee2c1912d">   42</a></span>&#160;    <span class="keyword">using</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_observer_interface.html#ad6a5305efc05863a6c2d49a2f40551f7">SourceId</a> = <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">avsCommon::utils::mediaPlayer::MediaPlayerInterface::SourceId</a>;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keyword">static</span> std::shared_ptr&lt;NotificationRenderer&gt; <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a4a5d997dba5c5c6ddc53810851e4098b">create</a>(</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        std::shared_ptr&lt;avsCommon::utils::mediaPlayer::MediaPlayerInterface&gt; mediaPlayer);</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a8c1b7c1018c83e406a041d27eb6bb26d">addObserver</a>(std::shared_ptr&lt;NotificationRendererObserverInterface&gt; observer) <span class="keyword">override</span>;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#aa6b7fa67a467fd23a84feac79fdb9e9f">removeObserver</a>(std::shared_ptr&lt;NotificationRendererObserverInterface&gt; observer) <span class="keyword">override</span>;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#ab90f400f6d91e73371bbe8afbf3ced56">renderNotification</a>(std::function&lt;std::unique_ptr&lt;std::istream&gt;()&gt; audioFactory, <span class="keyword">const</span> std::string&amp; url)</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keyword">override</span>;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a4f590589d4503fd32ee47fdc1b683b72">cancelNotificationRendering</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#afb9e6e4e006d2cf7422269976a286976">onPlaybackStarted</a>(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_observer_interface.html#ad6a5305efc05863a6c2d49a2f40551f7">SourceId</a> sourceId) <span class="keyword">override</span>;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a61c4c912c3a8e4bf134c00e455d87b4c">onPlaybackStopped</a>(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_observer_interface.html#ad6a5305efc05863a6c2d49a2f40551f7">SourceId</a> sourceId) <span class="keyword">override</span>;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a0eed26bd2aaf46e3ee5adff4a7f3558f">onPlaybackFinished</a>(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_observer_interface.html#ad6a5305efc05863a6c2d49a2f40551f7">SourceId</a> sourceId) <span class="keyword">override</span>;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a7481adf620475d8fb0f2b8970d7a1284">onPlaybackError</a>(<a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_observer_interface.html#ad6a5305efc05863a6c2d49a2f40551f7">SourceId</a> sourceId, <span class="keyword">const</span> <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player.html#ab6ff57ee3fc3650d3b710fa12d32e25d">avsCommon::utils::mediaPlayer::ErrorType</a>&amp; type, std::string error)</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="keyword">override</span>;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a8cfe9c19a236cefed6242f7dbf7442ec">doShutdown</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keyword">enum class</span> State {</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#af150b2d10515e0e7347e09a69986a47baa5daf7f2ebbba4975d61dab1c40188c7">IDLE</a>,</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        RENDERING_PREFERRED,</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        RENDERING_DEFAULT,</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        CANCELLING,</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;        NOTIFYING</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    };</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html">NotificationRenderer</a>(std::shared_ptr&lt;avsCommon::utils::mediaPlayer::MediaPlayerInterface&gt; mediaPlayer);</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordtype">void</span> onRenderingFinished(<a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#abd6892a98cfba046d6f02deee2c1912d">SourceId</a> sourceId);</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <span class="keywordtype">bool</span> setState(State newState);</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    <span class="keywordtype">bool</span> setStateLocked(State newState);</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    <span class="keywordtype">bool</span> verifyRenderingLocked(<span class="keyword">const</span> std::string&amp; caller, <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#abd6892a98cfba046d6f02deee2c1912d">SourceId</a> sourceId);</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    std::shared_ptr&lt;avsCommon::utils::mediaPlayer::MediaPlayerInterface&gt; m_mediaPlayer;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    std::unordered_set&lt;std::shared_ptr&lt;NotificationRendererObserverInterface&gt;&gt; m_observers;</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    std::mutex m_mutex;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    std::condition_variable m_wakeTrigger;</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    State m_state;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    std::function&lt;std::unique_ptr&lt;std::istream&gt;()&gt; m_audioFactory;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#abd6892a98cfba046d6f02deee2c1912d">SourceId</a> m_sourceId;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    std::future&lt;void&gt; m_renderFallbackFuture;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a54456c40b220b950fa455f3875980d94">operator&lt;&lt;</a>(std::ostream&amp; stream, <span class="keyword">const</span> NotificationRenderer::State state);</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;};</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;}  <span class="comment">// namespace notifications</span></div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;}  <span class="comment">// namespace capabilityAgents</span></div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_CAPABILITYAGENTS_NOTIFICATIONS_INCLUDE_NOTIFICATIONS_NOTIFICATIONRENDERER_H_</span></div><div class="ttc" id="_media_player_observer_interface_8h_html"><div class="ttname"><a href="_media_player_observer_interface_8h.html">MediaPlayerObserverInterface.h</a></div></div>
<div class="ttc" id="_requires_shutdown_8h_html"><div class="ttname"><a href="_requires_shutdown_8h.html">RequiresShutdown.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface_html_a97b83ae4aaeabff7bb8a796a8a018623"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_interface.html#a97b83ae4aaeabff7bb8a796a8a018623">alexaClientSDK::avsCommon::utils::mediaPlayer::MediaPlayerInterface::SourceId</a></div><div class="ttdeci">uint64_t SourceId</div><div class="ttdoc">A type that identifies which source is currently being operated on. </div><div class="ttdef"><b>Definition:</b> MediaPlayerInterface.h:60</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_html_a7481adf620475d8fb0f2b8970d7a1284"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a7481adf620475d8fb0f2b8970d7a1284">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer::onPlaybackError</a></div><div class="ttdeci">void onPlaybackError(SourceId sourceId, const avsCommon::utils::mediaPlayer::ErrorType &amp;type, std::string error) override</div><div class="ttdef"><b>Definition:</b> NotificationRenderer.cpp:191</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_interface.html">alexaClientSDK::capabilityAgents::notifications::NotificationRendererInterface</a></div><div class="ttdef"><b>Definition:</b> NotificationRendererInterface.h:32</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1avs_html_af150b2d10515e0e7347e09a69986a47baa5daf7f2ebbba4975d61dab1c40188c7"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html#af150b2d10515e0e7347e09a69986a47baa5daf7f2ebbba4975d61dab1c40188c7">alexaClientSDK::avsCommon::avs::PlayerActivity::IDLE</a></div><div class="ttdoc">Initial state, prior to acting on the first Play directive. </div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">alexaClientSDK::avsCommon::utils::RequiresShutdown</a></div><div class="ttdef"><b>Definition:</b> RequiresShutdown.h:32</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_html_a61c4c912c3a8e4bf134c00e455d87b4c"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a61c4c912c3a8e4bf134c00e455d87b4c">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer::onPlaybackStopped</a></div><div class="ttdeci">void onPlaybackStopped(SourceId sourceId) override</div><div class="ttdef"><b>Definition:</b> NotificationRenderer.cpp:173</div></div>
<div class="ttc" id="_media_player_interface_8h_html"><div class="ttname"><a href="_media_player_interface_8h.html">MediaPlayerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_html_afb9e6e4e006d2cf7422269976a286976"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#afb9e6e4e006d2cf7422269976a286976">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer::onPlaybackStarted</a></div><div class="ttdeci">void onPlaybackStarted(SourceId sourceId) override</div><div class="ttdef"><b>Definition:</b> NotificationRenderer.cpp:162</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_html_ab90f400f6d91e73371bbe8afbf3ced56"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#ab90f400f6d91e73371bbe8afbf3ced56">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer::renderNotification</a></div><div class="ttdeci">bool renderNotification(std::function&lt; std::unique_ptr&lt; std::istream &gt;()&gt; audioFactory, const std::string &amp;url) override</div><div class="ttdef"><b>Definition:</b> NotificationRenderer.cpp:100</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer</a></div><div class="ttdef"><b>Definition:</b> NotificationRenderer.h:35</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_html_a0eed26bd2aaf46e3ee5adff4a7f3558f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a0eed26bd2aaf46e3ee5adff4a7f3558f">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer::onPlaybackFinished</a></div><div class="ttdeci">void onPlaybackFinished(SourceId sourceId) override</div><div class="ttdef"><b>Definition:</b> NotificationRenderer.cpp:182</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_observer_interface_html_ad6a5305efc05863a6c2d49a2f40551f7"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_observer_interface.html#ad6a5305efc05863a6c2d49a2f40551f7">alexaClientSDK::avsCommon::utils::mediaPlayer::MediaPlayerObserverInterface::SourceId</a></div><div class="ttdeci">MediaPlayerInterface::SourceId SourceId</div><div class="ttdoc">A type that identifies which source is currently being operated on. </div><div class="ttdef"><b>Definition:</b> MediaPlayerObserverInterface.h:48</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_html_a54456c40b220b950fa455f3875980d94"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a54456c40b220b950fa455f3875980d94">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer::operator&lt;&lt;</a></div><div class="ttdeci">friend std::ostream &amp; operator&lt;&lt;(std::ostream &amp;stream, const NotificationRenderer::State state)</div><div class="ttdoc">Friend relationship to allow accessing State to convert it to a string for logging. </div><div class="ttdef"><b>Definition:</b> NotificationRenderer.cpp:45</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_html_a8cfe9c19a236cefed6242f7dbf7442ec"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a8cfe9c19a236cefed6242f7dbf7442ec">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer::doShutdown</a></div><div class="ttdeci">void doShutdown() override</div><div class="ttdef"><b>Definition:</b> NotificationRenderer.cpp:67</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_html_a4f590589d4503fd32ee47fdc1b683b72"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a4f590589d4503fd32ee47fdc1b683b72">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer::cancelNotificationRendering</a></div><div class="ttdeci">bool cancelNotificationRendering() override</div><div class="ttdef"><b>Definition:</b> NotificationRenderer.cpp:148</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_html_aa6b7fa67a467fd23a84feac79fdb9e9f"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#aa6b7fa67a467fd23a84feac79fdb9e9f">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer::removeObserver</a></div><div class="ttdeci">void removeObserver(std::shared_ptr&lt; NotificationRendererObserverInterface &gt; observer) override</div><div class="ttdef"><b>Definition:</b> NotificationRenderer.cpp:94</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_html_ab6ff57ee3fc3650d3b710fa12d32e25d"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player.html#ab6ff57ee3fc3650d3b710fa12d32e25d">alexaClientSDK::avsCommon::utils::mediaPlayer::ErrorType</a></div><div class="ttdeci">ErrorType</div><div class="ttdoc">Identifies the specific type of error in a PlaybackFailed event. </div><div class="ttdef"><b>Definition:</b> ErrorTypes.h:27</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_html_a4a5d997dba5c5c6ddc53810851e4098b"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a4a5d997dba5c5c6ddc53810851e4098b">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer::create</a></div><div class="ttdeci">static std::shared_ptr&lt; NotificationRenderer &gt; create(std::shared_ptr&lt; avsCommon::utils::mediaPlayer::MediaPlayerInterface &gt; mediaPlayer)</div><div class="ttdef"><b>Definition:</b> NotificationRenderer.cpp:77</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_observer_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1media_player_1_1_media_player_observer_interface.html">alexaClientSDK::avsCommon::utils::mediaPlayer::MediaPlayerObserverInterface</a></div><div class="ttdef"><b>Definition:</b> MediaPlayerObserverInterface.h:45</div></div>
<div class="ttc" id="_notification_renderer_interface_8h_html"><div class="ttname"><a href="_notification_renderer_interface_8h.html">NotificationRendererInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_html_abd6892a98cfba046d6f02deee2c1912d"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#abd6892a98cfba046d6f02deee2c1912d">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer::SourceId</a></div><div class="ttdeci">avsCommon::utils::mediaPlayer::MediaPlayerInterface::SourceId SourceId</div><div class="ttdoc">A type that identifies which source is currently being operated on. </div><div class="ttdef"><b>Definition:</b> NotificationRenderer.h:42</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer_html_a8c1b7c1018c83e406a041d27eb6bb26d"><div class="ttname"><a href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notification_renderer.html#a8c1b7c1018c83e406a041d27eb6bb26d">alexaClientSDK::capabilityAgents::notifications::NotificationRenderer::addObserver</a></div><div class="ttdeci">void addObserver(std::shared_ptr&lt; NotificationRendererObserverInterface &gt; observer) override</div><div class="ttdef"><b>Definition:</b> NotificationRenderer.cpp:88</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
